apiVersion: {{ hpa_apivers }}
kind: HorizontalPodAutoscaler
metadata:
  name: {{ autoscale_name }}
  namespace: {{ namespace }}
spec:
  maxReplicas: {{ hpa_max_replicas }}
  minReplicas: {{ hpa_min_replicas }}
  scaleTargetRef:
    apiVersion: {{ hpa_object_apiversion }}
    name: {{ hpa_object_watch }}
    kind: {{ hpa_object_kind }}
{% if hpa_apivers == "autoscaling/v2beta1" %}
  metrics:
{% if hpa_cpu_target_pct != False %}
  - type: Resource
    resource:
      name: cpu
      targetAverageUtilization: {{ hpa_cpu_target_pct }}
{% endif %}
{% if hpa_mem_target_pct != False %}
  - type: Resource
    resource:
      name: memory
      targetAverageUtilization: {{ hpa_mem_target_pct }}
{% endif %}
{% elif hpa_apivers == "autoscaling/v2beta2" %}
  metrics:
{% if hpa_cpu_target_pct != False %}
  - type: Resource
    resource:
      name: cpu
      target:
        type: Utilization
        averageUtilization: {{ hpa_cpu_target_pct }}
{% endif %}
{% if hpa_mem_target_pct != False %}
  - type: Resource
    resource:
     name: memory
     target:
       type: Utilization
       averageUtilization: {{ hpa_mem_target_pct }}
{% endif %}
  behavior:
    scaleDown:
      stabilizationWindowSeconds: 300
      policies:
      - type: Pods
        value: 1
        periodSeconds: 60
      - type: Percent
        value: 20
        periodSeconds: 60
{% elif hpa_cpu_target_pct != False %}
  targetCPUUtilizationPercentage: {{ hpa_cpu_target_pct }}
{% else %}
  targetCPUUtilizationPercentage: 75
{% endif %}
